import sublime
import sublime_plugin
import os
import sys
import subprocess
__dir__ = os.path.dirname(os.path.realpath(__file__));
found_directory = False;
for index, item in enumerate(sys.path):
  if item == __dir__:
    found_directory = True;
if found_directory == False:
  sys.path.insert(1, __dir__)

class FcfGetPathCommand(sublime_plugin.WindowCommand):
  def __init__(self, view):
    super(FcfGetPathCommand, self).__init__(view)

  def is_enabled_(self, args):    
    return True

  def run(self, **args):
    path = None

    try:
      if len(args["dirs"]) != 0:
        path = args["dirs"][0]
      elif len(args["files"]) != 0:
        path = args["files"][0]
    except:
      return

    if path == None:
      return
 
    try:
      import pyperclip
      pyperclip.copy(path)
    except:
      import pyp3rclip
      pyp3rclip.copy(path)


class FcfInsertSubTemplateCommand(sublime_plugin.TextCommand):
    def run(self, edit, **args):
      self.view.window().show_input_panel("Enter subtemplate name:", "", self._onDoneInput, None, None)
      return True;

    def _onDoneInput(self, inputString):
      self.view.run_command('fcf_insert_subtemplate_input', {"subtemplate": inputString } )
      #self.view.insert(self._edit, self._selections[0].end(), "//~OPTIONS ")

    def is_active():
      return True


class fcfInsertSubtemplateInputCommand(sublime_plugin.TextCommand):
    def run(self, edit, **args):
      selections = self.view.sel()
      selections.clear()
      selections.add(sublime.Region(self.view.size(), self.view.size()))
      text  = "//~OPTIONS " + args["subtemplate"] + "\n"
      text += "{\n"
      text += "  //en Automatic template update mode when the argument changes.\n"
      text += "  //en Acceptable values:\n"
      text += "  //en true|\"all\" - The update is performed on any change\n"
      text += "  //en \"external\" - The update is performed only if the external template was the initiator of the change.\n"
      text += "  //en false      - The template is not being updated\n"
      text += "  autoUpdate: false,\n"
      text += "\n"
      text += "  // If true, the rendering is performed on the client side\n"
      text += "  clientRenderting: false,\n"
      text += "\n"
      text += "  // Additional JS & CSS files to connect (JS files are also connected on the server side)\n"
      text += "  include: [],\n"
      text += "\n"
      text += "  // Plug-in additional JS & CSS files on the client side\n"
      text += "  clientInclude: [],\n"
      text += "}\n"
      text += "\n"
      text += "//~ARGUMENTS " + args["subtemplate"] + "\n"
      text += "{\n"
      text += "\n"
      text += "}\n"
      text += "\n"
      text += "//~TEMPLATE " + args["subtemplate"] + "\n"
      self.view.insert(edit, selections[0].end(), text)
      return True;


class FcfNewTemplateCommand(sublime_plugin.WindowCommand):
  def __init__(self, window):
    super(FcfNewTemplateCommand, self).__init__(window)
    self._directory = None
    self._args      = None
    self._template  = None

  def run(self, **args):
    try:
      self._directory = ""
      self._args      = {"file": "", "extends": ""}
      self._template  = args["fcftemplate"]
      if len(args["dirs"]) != 0:
        self._directory = args["dirs"][0]
      elif len(args["files"]) != 0:
        self._directory = os.path.dirname(args["files"][0])
    except:
      return True

    if self._directory == None:
      return

    if self._template == "template" or self._template == "template-file" or self._template == "wrapper":
      self.window.show_input_panel("Enter file name:", "", self._onDoneInputWithInheritFile, None, None)
    else:
      self.window.show_input_panel("Enter file name:", "", self._onDoneInput, None, None)

  def _onDoneInput(self, inputString):
    self._args["file"] = inputString.strip();
    self._action();
    return


  def _onDoneInputWithInheritFile(self, inputString):
    self._args["file"] = inputString.strip();
    self.window.show_input_panel("Enter extends file name (Can be empty):", "", self._onDoneInputWithInheritExtends, None, None)
    return

  def _onDoneInputWithInheritExtends(self, inputString):
    self._args["extends"] = inputString.strip();
    self._action();
    return


  def _action(self):
    try:
      if len(self._directory) == 0:
        return
      if len(self._args["file"]) == 0:
        return
      if len(self._args["extends"]) == 0:
        subprocess.Popen(["fcfmngr", "c", self._template, self._args["file"]], cwd=self._directory)
      else:
        subprocess.Popen(["fcfmngr", "c", self._template, self._args["file"], self._args["extends"]], cwd=self._directory)
    except e:
      print(e)
